1. Write code to initialize a chrome browser
service=ChromeServices(executable_path=ChromeDriverManager().install())
driver=webdriver.Chrome(service=service)
driver.implicitly_wait(3)

2.What are the imports you using for this initilization?
from selenium import webdriver
from selenium.webdriver.chrome.service import Service as ChromeService
from selenium.webdriver.chrome.options import Options as ChromeOptions
from webdriver_manager.chrome import ChromeDriverManager

3. Write code to initialize an edge browser
from selenium.webdriver.edge.webdriver import WebDriver

4.Write code to initialize a firefox browser
from selenium.webdriver.firefox.webdriver import WebDriver

5.What happens when you run the above code in question1?
when you run the above code  chrome browser will get initialized.

6.WCT navigate to a specific url ex:www.google.com
try:
   driver.get("www.google.com")
except Exception as e:
   print("Unexpected error occurred:{e}")
finally:
   driver.quit()
   print("Closing the Windows...")


7.WCT maximize the Browser
driver.maximize_window()

8.WCT implement the implicit wait
driver.implicitly_wait(3)

9.What is implicit wait and when do you use it? When do you need to stop it, give an example.
Implicit wait allows the webdriver to wait for a certain amount of time before throwing "NoSuchElementExcetion".
Example Program:
from selenium import webdriver
from selenium.webdriver.chrome.service import Service as ChromeService
from selenium.webdriver.chrome.options import Options as ChromeOptions
from webdriver_manager.chrome import ChromeDriverManager

service=ChromeServices(executable_path=ChromeDriverManager().install())
driver=webdriver.Chrome(service=service)
wait=driver.implicitly_wait(3)
url="www.google.com"
driver.maximize_window()
try:
	driver.get(url)
	search_bar=driver.find_element(By.XPATH,'//input[@type="searchbar"]")
	wait.untill(EC.visibility_of_element(search_bar))
except TimeoutException as e:
	print(f"Timeout error occurred:{e}")
except NoSuchElementExcetion as e:
	print(f"Error finding the element:{e}")
except Exception as e:
	print(f"Unexpected error occured:{e}")

finally:
	driver.quit()
	print("Closing the windows...")

10.WCT launch a Browser, navigate to url:"https://testautomationpractice.blogspot.com/"
write code to login. Assume that you are writing in the notepad.

from selenium import webdriver
from selenium.webdriver.chrome.service import Service as ChromeService
from selenium.webdriver.chrome.options import Options as ChromeOptions
from webdriver_manager.chrome import ChromeDriverManager
service=ChromeServices(executable_path=ChromeDriverManager().install())
driver=webdriver.Chrome(service=service)
driver.implicitly_wait(3)
try:
      	driver.get("https://testautomationpractice.blogspot.com/")
	driver.maximize_window()
	username=driver.find_element(By.Xpath,"//input[@name="username"]
	password=driver.find_element(By.Xpath,"//input[@type="password"]
	login=driver.find_element(By.Xpath,"//input[@type="submit"]
	username.send_keys("admin")
	password.send_keys("admin@123")
	login.click()

except TimeoutException as e:
	print(f"Timeout error occurred:{e}")
except NoSuchElementExcetion as e:
	print(f"Error finding the element:{e}")
except Exception as e:
	print(f"Unexpected error occured:{e}")

finally:
	driver.quit()
	print("Closing the windows...")

11.WCT check if a button is present in the page

from selenium.webdriver.chrome.webdriver import WebDriver
from selenium.webdriver.common.by import By
import time

driver=WebDriver()
driver.maximize_window()
url="https://practicetestautomation.com/practice-test-login/"
try:
    driver.get(url)
    print(f"URL:{driver.current_url}")
    button=driver.find_element(By.XPATH,'//button[@id="submit"]')
    print(f"Button text:{button.text}")
    if button.is_displayed():
        print("Button is displayed")
    else:
        print("Button is not displayed")

except Exception as e:
    print(f"Unexpected error occurred:{e}")

finally:
    driver.quit()
    print("Closing the windows...")

12. WCT if a button is present in the page and validate if the button contains login text
from selenium.webdriver.chrome.webdriver import WebDriver
from selenium.webdriver.common.by import By
driver=WebDriver()
driver.maximize_window()
url="https://practicetestautomation.com/practice-test-login/"
try:
    driver.get(url)
    print(f"URL:{driver.current_url}")
    button=driver.find_element(By.XPATH,'//button[@id="submit"]')
    print(f"Button text:{button.text}")
    if button.text=="Submit":
        print("Button Validated")
    else:
        print("Validation failed")

except Exception as e:
    print(f"Unexpected error occurred:{e}")

finally:
    driver.quit()
    print("Closing the windows...")

13. WCT to count the total number of textboxes, images and links present in the page using single Xpath
from selenium.webdriver.chrome.webdriver import WebDriver
from selenium.webdriver.common.by import By
import time
driver=WebDriver()
driver.maximize_window()
url="https://practicetestautomation.com/practice-test-login/"
try:
    driver.get(url)
    print(f"URL:{driver.current_url}")
    txtbox=driver.find_elements(By.XPATH,'//input[@type="text"]')
    lnk=driver.find_elements(By.XPATH,"//a")
    image=driver.find_elements(By.XPATH,'//img')
    total=driver.find_elements(By.XPATH,'//input[@type="text"]|//a|//img')
    textbox=0
    link=0
    img=0
    for elements in total:
        if elements in lnk:
            link+=1
        elif elements in txtbox:
            textbox+=1
        else:
            img+=1
    print(textbox)
    print(link)
    print(img)

except Exception as e:
    print(f"Unexpected error occurred:{e}")

finally:
    driver.quit()
    print("Closing the windows...")

14.WCT launch a browser, navigate to a url,validate the url, validate the title, and validate if the login is present
from selenium.webdriver.chrome.webdriver import WebDriver
from selenium.webdriver.common.by import By
driver=WebDriver()
driver.maximize_window()
url="https://practicetestautomation.com/practice-test-login/"
print("Expected URL:'https://practicetestautomation.com/practice-test-login'")
try:
    driver.get(url)
    print(f"Current URL:{driver.current_url}")
    if driver.current_url==url:
        print("URL validated")
except Exception as e:
    print(f"Unexpected error occurred:{e}")

finally:
    driver.quit()
    print("Closing the windows...")

15. WCT after login ,Validate the Landing(HomePage)? What will you validate?
Validating the landing(HomePage) means we are ensuring that the user is redirected to the current URL where the home page elements are
displayed. This includes checking for any Welcome messages or Headings.

16. WCT to fetch the count of all the links in the page
from selenium.webdriver.chrome.webdriver import WebDriver
from selenium.webdriver.common.by import By
driver=WebDriver()
driver.maximize_window()
url="https://practicetestautomation.com/practice-test-login/"
try:
    driver.get(url)
    print(f"URL:{driver.current_url}")
    link=driver.find_elements(By.TAG_NAME,'a')
    print(len(link))

except Exception as e:
    print(f"Unexpected error occurred:{e}")

finally:
    driver.quit()
    print("Closing the windows...")

17.WCT print all the broken links in the page
import requests
from selenium.webdriver.chrome.webdriver import WebDriver
from selenium.webdriver.common.by import By
driver=WebDriver()
driver.maximize_window()
url="https://demo.testfire.net/"
try:
    driver.get(url)
    print(f"URL:{driver.current_url}")
    links=driver.find_elements(By.TAG_NAME,'a')
    print(len(links))
    for link in links:
        url=link.get_attribute("href")
        
        try:
            response=requests.head(url,timeout=5)
            if response.status_code>=400:
                print(url)
        except:
            pass


except Exception as e:
    print(f"Unexpected error occurred:{e}")

finally:
    driver.quit()
    print("Closing the windows...")


18.WCT print the tool tip for all the images in a page(only if present)

19.What is webdriver-manager and why do we need to use it?
WebDriver Manager is a Python library that automates the downloading, installation, and management of browser drivers required
for Selenium tests.
WebDriver Manager figures out which browser and version you’re using (like Chrome or Firefox).
It finds and downloads the correct driver, based on your browser version(for example, ChromeDriver for Chrome).

20.Explain the difference between driver.close() and driver.quit() in Selenium Python.
driver.close() method closes the current working window.
driver.quit() method quits the driver by closing all the associated windows.

21.Why is using time.sleep() generally bad practise in Selenium scripts? What should be used instead?
time.sleep() pauses the script for a fixed duration, regardless of whether the element you're waiting for is already available.
This leads to unnecessary delays and increases test execution time

22.What is Python Virtual enviromnent(venv) and why should you use one for Selenium projects? 
A virtual environment(venv) is a self contained directory tree that includes Python installatio for a particular version of Python plus a 
number of additional packages.Its having a clean, separate python setup for each python projects.